diff -uNrw asterisk-1.8.19.0/main/astmm.c asterisk-1.8.20.0-rc1/main/astmm.c
--- asterisk-1.8.19.0/main/astmm.c	2012-09-08 01:05:21.000000000 +0200
+++ asterisk-1.8.20.0-rc1/main/astmm.c	2012-12-08 00:40:19.000000000 +0100
@@ -1,7 +1,7 @@
 /*
  * Asterisk -- An open source telephony toolkit.
  *
- * Copyright (C) 1999 - 2006, Digium, Inc.
+ * Copyright (C) 1999 - 2012, Digium, Inc.
  *
  * Mark Spencer <markster@digium.com>
  *
@@ -21,6 +21,7 @@
  * \brief Memory Management
  *
  * \author Mark Spencer <markster@digium.com>
+ * \author Richard Mudgett <rmudgett@digium.com>
  */
 
 /*** MODULEINFO
@@ -29,9 +30,9 @@
 
 #include "asterisk.h"
 
-#ifdef __AST_DEBUG_MALLOC
+#if defined(__AST_DEBUG_MALLOC)
 
-ASTERISK_FILE_VERSION(__FILE__, "$Revision: 372655 $")
+ASTERISK_FILE_VERSION(__FILE__, "$Revision: 377398 $")
 
 #include "asterisk/paths.h"	/* use ast_config_AST_LOG_DIR */
 #include <stddef.h>
@@ -42,7 +43,12 @@
 #include "asterisk/strings.h"
 #include "asterisk/unaligned.h"
 
-#define SOME_PRIME 563
+/*!
+ * The larger the number the faster memory can be freed.
+ * However, more memory then is used for the regions[] hash
+ * table.
+ */
+#define SOME_PRIME 1567
 
 enum func_type {
 	FUNC_CALLOC = 1,
@@ -64,36 +70,79 @@
 #undef vasprintf
 #undef asprintf
 
-#define FENCE_MAGIC 0xdeadbeef
+#define FENCE_MAGIC		0xdeadbeef	/*!< Allocated memory high/low fence overwrite check. */
+#define FREED_MAGIC		0xdeaddead	/*!< Freed memory wipe filler. */
+#define MALLOC_FILLER	0x55		/*!< Malloced memory filler.  Must not be zero. */
 
 static FILE *mmlog;
 
-/* NOTE: Be EXTREMELY careful with modifying this structure; the total size of this structure
-   must result in 'automatic' alignment so that the 'fence' field lands exactly at the end of
-   the structure in memory (and thus immediately before the allocated region the fence is
-   supposed to be used to monitor). In other words, we cannot allow the compiler to insert
-   any padding between this structure and anything following it, so add up the sizes of all the
-   fields and compare to sizeof(struct ast_region)... if they don't match, then the compiler
-   is padding the structure and either the fields need to be rearranged to eliminate internal
-   padding, or a dummy field will need to be inserted before the 'fence' field to push it to
-   the end of the actual space it will consume. Note that this must be checked for both 32-bit
-   and 64-bit platforms, as the sizes of pointers and 'size_t' differ on these platforms.
-*/
-
-static struct ast_region {
-	struct ast_region *next;
+struct ast_region {
+	AST_LIST_ENTRY(ast_region) node;
 	size_t len;
-	char file[64];
-	char func[40];
+	unsigned int cache;		/* region was allocated as part of a cache pool */
 	unsigned int lineno;
 	enum func_type which;
-	unsigned int cache;		/* region was allocated as part of a cache pool */
+	char file[64];
+	char func[40];
+
+	/*!
+	 * \brief Lower guard fence.
+	 *
+	 * \note Must be right before data[].
+	 *
+	 * \note Padding between fence and data[] is irrelevent because
+	 * data[] is used to fill in the lower fence check value and not
+	 * the fence member.  The fence member is to ensure that there
+	 * is space reserved for the fence check value.
+	 */
 	unsigned int fence;
-	unsigned char data[0];
-} *regions[SOME_PRIME];
+	/*!
+	 * \brief Location of the requested malloc block to return.
+	 *
+	 * \note Must have the same alignment that malloc returns.
+	 * i.e., It is suitably aligned for any kind of varible.
+	 */
+	unsigned char data[0] __attribute__((aligned));
+};
+
+/*! Hash table of lists of active allocated memory regions. */
+static struct ast_region *regions[SOME_PRIME];
+
+/*! Number of freed regions to keep around to delay actually freeing them. */
+#define FREED_MAX_COUNT		1500
+
+/*! Maximum size of a minnow block */
+#define MINNOWS_MAX_SIZE	50
+
+struct ast_freed_regions {
+	/*! Memory regions that have been freed. */
+	struct ast_region *regions[FREED_MAX_COUNT];
+	/*! Next index into freed regions[] to use. */
+	int index;
+};
+
+/*! Large memory blocks that have been freed. */
+static struct ast_freed_regions whales;
+/*! Small memory blocks that have been freed. */
+static struct ast_freed_regions minnows;
+
+enum summary_opts {
+	/*! No summary at exit. */
+	SUMMARY_OFF,
+	/*! Bit set if summary by line at exit. */
+	SUMMARY_BY_LINE = (1 << 0),
+	/*! Bit set if summary by function at exit. */
+	SUMMARY_BY_FUNC = (1 << 1),
+	/*! Bit set if summary by file at exit. */
+	SUMMARY_BY_FILE = (1 << 2),
+};
+
+/*! Summary options of unfreed regions at exit. */
+static enum summary_opts atexit_summary;
+/*! Nonzero if the unfreed regions are listed at exit. */
+static int atexit_list;
 
-#define HASH(a) \
-	(((unsigned long)(a)) % SOME_PRIME)
+#define HASH(a)		(((unsigned long)(a)) % ARRAY_LEN(regions))
 
 /*! Tracking this mutex will cause infinite recursion, as the mutex tracking
  *  code allocates memory */
@@ -108,95 +157,285 @@
 		}                                    \
 	} while (0)
 
-static inline void *__ast_alloc_region(size_t size, const enum func_type which, const char *file, int lineno, const char *func, unsigned int cache)
+/*!
+ * \internal
+ *
+ * \note If DO_CRASH is not defined then the function returns.
+ *
+ * \return Nothing
+ */
+static void my_do_crash(void)
+{
+	/*
+	 * Give the logger a chance to get the message out, just in case
+	 * we abort(), or Asterisk crashes due to whatever problem just
+	 * happened.
+	 */
+	usleep(1);
+	ast_do_crash();
+}
+
+static void *__ast_alloc_region(size_t size, const enum func_type which, const char *file, int lineno, const char *func, unsigned int cache)
 {
 	struct ast_region *reg;
-	void *ptr = NULL;
 	unsigned int *fence;
 	int hash;
 
 	if (!(reg = malloc(size + sizeof(*reg) + sizeof(*fence)))) {
-		astmm_log("Memory Allocation Failure - '%d' bytes in function %s "
-			  "at line %d of %s\n", (int) size, func, lineno, file);
+		astmm_log("Memory Allocation Failure - '%d' bytes at %s %s() line %d\n",
+			(int) size, file, func, lineno);
 		return NULL;
 	}
 
-	ast_copy_string(reg->file, file, sizeof(reg->file));
-	ast_copy_string(reg->func, func, sizeof(reg->func));
-	reg->lineno = lineno;
 	reg->len = size;
-	reg->which = which;
 	reg->cache = cache;
-	ptr = reg->data;
-	hash = HASH(ptr);
-	reg->fence = FENCE_MAGIC;
-	fence = (ptr + reg->len);
+	reg->lineno = lineno;
+	reg->which = which;
+	ast_copy_string(reg->file, file, sizeof(reg->file));
+	ast_copy_string(reg->func, func, sizeof(reg->func));
+
+	/*
+	 * Init lower fence.
+	 *
+	 * We use the bytes just preceeding reg->data and not reg->fence
+	 * because there is likely to be padding between reg->fence and
+	 * reg->data for reg->data alignment.
+	 */
+	fence = (unsigned int *) (reg->data - sizeof(*fence));
+	*fence = FENCE_MAGIC;
+
+	/* Init higher fence. */
+	fence = (unsigned int *) (reg->data + reg->len);
 	put_unaligned_uint32(fence, FENCE_MAGIC);
 
+	hash = HASH(reg->data);
 	ast_mutex_lock(&reglock);
-	reg->next = regions[hash];
+	AST_LIST_NEXT(reg, node) = regions[hash];
 	regions[hash] = reg;
 	ast_mutex_unlock(&reglock);
 
-	return ptr;
+	return reg->data;
 }
 
-static inline size_t __ast_sizeof_region(void *ptr)
+/*!
+ * \internal
+ * \brief Wipe the region payload data with a known value.
+ *
+ * \param reg Region block to be wiped.
+ *
+ * \return Nothing
+ */
+static void region_data_wipe(struct ast_region *reg)
 {
-	int hash = HASH(ptr);
-	struct ast_region *reg;
-	size_t len = 0;
+	void *end;
+	unsigned int *pos;
 	
-	ast_mutex_lock(&reglock);
-	for (reg = regions[hash]; reg; reg = reg->next) {
-		if (reg->data == ptr) {
-			len = reg->len;
+	/*
+	 * Wipe the lower fence, the payload, and whatever amount of the
+	 * higher fence that falls into alignment with the payload.
+	 */
+	end = reg->data + reg->len;
+	for (pos = &reg->fence; (void *) pos <= end; ++pos) {
+		*pos = FREED_MAGIC;
+	}
+}
+
+/*!
+ * \internal
+ * \brief Check the region payload data for memory corruption.
+ *
+ * \param reg Region block to be checked.
+ *
+ * \return Nothing
+ */
+static void region_data_check(struct ast_region *reg)
+{
+	void *end;
+	unsigned int *pos;
+
+	/*
+	 * Check the lower fence, the payload, and whatever amount of
+	 * the higher fence that falls into alignment with the payload.
+	 */
+	end = reg->data + reg->len;
+	for (pos = &reg->fence; (void *) pos <= end; ++pos) {
+		if (*pos != FREED_MAGIC) {
+			astmm_log("WARNING: Memory corrupted after free of %p allocated at %s %s() line %d\n",
+				reg->data, reg->file, reg->func, reg->lineno);
+			my_do_crash();
 			break;
 		}
 	}
+}
+
+/*!
+ * \internal
+ * \brief Flush the circular array of freed regions.
+ *
+ * \param freed Already freed region blocks storage.
+ *
+ * \return Nothing
+ */
+static void freed_regions_flush(struct ast_freed_regions *freed)
+{
+	int idx;
+	struct ast_region *old;
+
+	ast_mutex_lock(&reglock);
+	for (idx = 0; idx < ARRAY_LEN(freed->regions); ++idx) {
+		old = freed->regions[idx];
+		freed->regions[idx] = NULL;
+		if (old) {
+			region_data_check(old);
+			free(old);
+		}
+	}
+	freed->index = 0;
+	ast_mutex_unlock(&reglock);
+}
+
+/*!
+ * \internal
+ * \brief Delay freeing a region block.
+ *
+ * \param freed Already freed region blocks storage.
+ * \param reg Region block to be freed.
+ *
+ * \return Nothing
+ */
+static void region_free(struct ast_freed_regions *freed, struct ast_region *reg)
+{
+	struct ast_region *old;
+
+	region_data_wipe(reg);
+
+	ast_mutex_lock(&reglock);
+	old = freed->regions[freed->index];
+	freed->regions[freed->index] = reg;
+
+	++freed->index;
+	if (ARRAY_LEN(freed->regions) <= freed->index) {
+		freed->index = 0;
+	}
 	ast_mutex_unlock(&reglock);
 
-	return len;
+	if (old) {
+		region_data_check(old);
+		free(old);
+	}
 }
 
-static void __ast_free_region(void *ptr, const char *file, int lineno, const char *func)
+/*!
+ * \internal
+ * \brief Remove a region from the active regions.
+ *
+ * \param ptr Region payload data pointer.
+ *
+ * \retval region on success.
+ * \retval NULL if not found.
+ */
+static struct ast_region *region_remove(void *ptr)
 {
 	int hash;
-	struct ast_region *reg, *prev = NULL;
-	unsigned int *fence;
-
-	if (!ptr)
-		return;
+	struct ast_region *reg;
+	struct ast_region *prev = NULL;
 
 	hash = HASH(ptr);
 
 	ast_mutex_lock(&reglock);
-	for (reg = regions[hash]; reg; reg = reg->next) {
+	for (reg = regions[hash]; reg; reg = AST_LIST_NEXT(reg, node)) {
 		if (reg->data == ptr) {
-			if (prev)
-				prev->next = reg->next;
-			else
-				regions[hash] = reg->next;
+			if (prev) {
+				AST_LIST_NEXT(prev, node) = AST_LIST_NEXT(reg, node);
+			} else {
+				regions[hash] = AST_LIST_NEXT(reg, node);
+			}
 			break;
 		}
 		prev = reg;
 	}
 	ast_mutex_unlock(&reglock);
 
-	if (reg) {
-		fence = (unsigned int *)(reg->data + reg->len);
-		if (reg->fence != FENCE_MAGIC) {
-			astmm_log("WARNING: Low fence violation at %p, in %s of %s, "
-				"line %d\n", reg->data, reg->func, reg->file, reg->lineno);
+	return reg;
 		}
+
+/*!
+ * \internal
+ * \brief Check the fences of a region.
+ *
+ * \param reg Region block to check.
+ *
+ * \return Nothing
+ */
+static void region_check_fences(struct ast_region *reg)
+{
+	unsigned int *fence;
+
+	/*
+	 * We use the bytes just preceeding reg->data and not reg->fence
+	 * because there is likely to be padding between reg->fence and
+	 * reg->data for reg->data alignment.
+	 */
+	fence = (unsigned int *) (reg->data - sizeof(*fence));
+	if (*fence != FENCE_MAGIC) {
+		astmm_log("WARNING: Low fence violation of %p allocated at %s %s() line %d\n",
+			reg->data, reg->file, reg->func, reg->lineno);
+		my_do_crash();
+	}
+	fence = (unsigned int *) (reg->data + reg->len);
 		if (get_unaligned_uint32(fence) != FENCE_MAGIC) {
-			astmm_log("WARNING: High fence violation at %p, in %s of %s, "
-				"line %d\n", reg->data, reg->func, reg->file, reg->lineno);
+		astmm_log("WARNING: High fence violation of %p allocated at %s %s() line %d\n",
+			reg->data, reg->file, reg->func, reg->lineno);
+		my_do_crash();
+	}
+}
+
+/*!
+ * \internal
+ * \brief Check the fences of all regions currently allocated.
+ *
+ * \return Nothing
+ */
+static void regions_check_all_fences(void)
+{
+	int idx;
+	struct ast_region *reg;
+
+	ast_mutex_lock(&reglock);
+	for (idx = 0; idx < ARRAY_LEN(regions); ++idx) {
+		for (reg = regions[idx]; reg; reg = AST_LIST_NEXT(reg, node)) {
+			region_check_fences(reg);
+		}
+	}
+	ast_mutex_unlock(&reglock);
+}
+
+static void __ast_free_region(void *ptr, const char *file, int lineno, const char *func)
+{
+	struct ast_region *reg;
+
+	if (!ptr) {
+		return;
+	}
+
+	reg = region_remove(ptr);
+	if (reg) {
+		region_check_fences(reg);
+
+		if (reg->len <= MINNOWS_MAX_SIZE) {
+			region_free(&minnows, reg);
+		} else {
+			region_free(&whales, reg);
 		}
-		free(reg);
 	} else {
-		astmm_log("WARNING: Freeing unused memory at %p, in %s of %s, line %d\n",	
-			ptr, func, file, lineno);
+		/*
+		 * This memory region is not registered.  It could be because of
+		 * a double free or the memory block was not allocated by the
+		 * malloc debug code.
+		 */
+		astmm_log("WARNING: Freeing unregistered memory %p by %s %s() line %d\n",
+			ptr, file, func, lineno);
+		my_do_crash();
 	}
 }
 
@@ -204,8 +443,10 @@
 {
 	void *ptr;
 
-	if ((ptr = __ast_alloc_region(size * nmemb, FUNC_CALLOC, file, lineno, func, 0))) 
+	ptr = __ast_alloc_region(size * nmemb, FUNC_CALLOC, file, lineno, func, 0);
+	if (ptr) {
 		memset(ptr, 0, size * nmemb);
+	}
 
 	return ptr;
 }
@@ -214,15 +455,25 @@
 {
 	void *ptr;
 
-	if ((ptr = __ast_alloc_region(size * nmemb, FUNC_CALLOC, file, lineno, func, 1))) 
+	ptr = __ast_alloc_region(size * nmemb, FUNC_CALLOC, file, lineno, func, 1);
+	if (ptr) {
 		memset(ptr, 0, size * nmemb);
+	}
 
 	return ptr;
 }
 
 void *__ast_malloc(size_t size, const char *file, int lineno, const char *func) 
 {
-	return __ast_alloc_region(size, FUNC_MALLOC, file, lineno, func, 0);
+	void *ptr;
+
+	ptr = __ast_alloc_region(size, FUNC_MALLOC, file, lineno, func, 0);
+	if (ptr) {
+		/* Make sure that the malloced memory is not zero. */
+		memset(ptr, MALLOC_FILLER, size);
+	}
+
+	return ptr;
 }
 
 void __ast_free(void *ptr, const char *file, int lineno, const char *func) 
@@ -230,28 +481,71 @@
 	__ast_free_region(ptr, file, lineno, func);
 }
 
+/*!
+ * \note reglock must be locked before calling.
+ */
+static struct ast_region *region_find(void *ptr)
+{
+	int hash;
+	struct ast_region *reg;
+
+	hash = HASH(ptr);
+	for (reg = regions[hash]; reg; reg = AST_LIST_NEXT(reg, node)) {
+		if (reg->data == ptr) {
+			break;
+		}
+	}
+
+	return reg;
+}
+
 void *__ast_realloc(void *ptr, size_t size, const char *file, int lineno, const char *func) 
 {
-	void *tmp;
-	size_t len = 0;
+	size_t len;
+	struct ast_region *found;
+	void *new_mem;
 
-	if (ptr && !(len = __ast_sizeof_region(ptr))) {
-		astmm_log("WARNING: Realloc of unalloced memory at %p, in %s of %s, "
-			"line %d\n", ptr, func, file, lineno);
+	if (ptr) {
+		ast_mutex_lock(&reglock);
+		found = region_find(ptr);
+		if (!found) {
+			ast_mutex_unlock(&reglock);
+			astmm_log("WARNING: Realloc of unregistered memory %p by %s %s() line %d\n",
+				ptr, file, func, lineno);
+			my_do_crash();
 		return NULL;
 	}
+		len = found->len;
+		ast_mutex_unlock(&reglock);
+	} else {
+		found = NULL;
+		len = 0;
+	}
 
-	if (!(tmp = __ast_alloc_region(size, FUNC_REALLOC, file, lineno, func, 0)))
+	if (!size) {
+		__ast_free_region(ptr, file, lineno, func);
 		return NULL;
+	}
 
-	if (len > size)
-		len = size;
-	if (ptr) {
-		memcpy(tmp, ptr, len);
+	new_mem = __ast_alloc_region(size, FUNC_REALLOC, file, lineno, func, 0);
+	if (new_mem) {
+		if (found) {
+			/* Copy the old data to the new malloced memory. */
+			if (size <= len) {
+				memcpy(new_mem, ptr, size);
+			} else {
+				memcpy(new_mem, ptr, len);
+				/* Make sure that the added memory is not zero. */
+				memset(new_mem + len, MALLOC_FILLER, size - len);
+			}
 		__ast_free_region(ptr, file, lineno, func);
+		} else {
+			/* Make sure that the malloced memory is not zero. */
+			memset(new_mem, MALLOC_FILLER, size);
+		}
 	}
 	
-	return tmp;
+	return new_mem;
 }
 
 char *__ast_strdup(const char *s, const char *file, int lineno, const char *func) 
@@ -327,83 +621,195 @@
 	return size;
 }
 
-static char *handle_memory_show(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
+static char *handle_memory_atexit_list(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
+{
+	switch (cmd) {
+	case CLI_INIT:
+		e->command = "memory atexit list";
+		e->usage =
+			"Usage: memory atexit list {on|off}\n"
+			"       Enable dumping a list of still allocated memory segments at exit.\n";
+		return NULL;
+	case CLI_GENERATE:
+		if (a->pos == 3) {
+			const char * const options[] = { "off", "on", NULL };
+
+			return ast_cli_complete(a->word, options, a->n);
+		}
+		return NULL;
+	}
+
+	if (a->argc != 4) {
+		return CLI_SHOWUSAGE;
+	}
+
+	if (ast_true(a->argv[3])) {
+		atexit_list = 1;
+	} else if (ast_false(a->argv[3])) {
+		atexit_list = 0;
+	} else {
+		return CLI_SHOWUSAGE;
+	}
+
+	ast_cli(a->fd, "The atexit list is: %s\n", atexit_list ? "On" : "Off");
+
+	return CLI_SUCCESS;
+}
+
+static char *handle_memory_atexit_summary(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
+{
+	char buf[80];
+
+	switch (cmd) {
+	case CLI_INIT:
+		e->command = "memory atexit summary";
+		e->usage =
+			"Usage: memory atexit summary {off|byline|byfunc|byfile}\n"
+			"       Summary of still allocated memory segments at exit options.\n"
+			"       off - Disable at exit summary.\n"
+			"       byline - Enable at exit summary by file line number.\n"
+			"       byfunc - Enable at exit summary by function name.\n"
+			"       byfile - Enable at exit summary by file.\n"
+			"\n"
+			"       Note: byline, byfunc, and byfile are cumulative enables.\n";
+		return NULL;
+	case CLI_GENERATE:
+		if (a->pos == 3) {
+			const char * const options[] = { "off", "byline", "byfunc", "byfile", NULL };
+
+			return ast_cli_complete(a->word, options, a->n);
+		}
+		return NULL;
+	}
+
+	if (a->argc != 4) {
+		return CLI_SHOWUSAGE;
+	}
+
+	if (ast_false(a->argv[3])) {
+		atexit_summary = SUMMARY_OFF;
+	} else if (!strcasecmp(a->argv[3], "byline")) {
+		atexit_summary |= SUMMARY_BY_LINE;
+	} else if (!strcasecmp(a->argv[3], "byfunc")) {
+		atexit_summary |= SUMMARY_BY_FUNC;
+	} else if (!strcasecmp(a->argv[3], "byfile")) {
+		atexit_summary |= SUMMARY_BY_FILE;
+	} else {
+		return CLI_SHOWUSAGE;
+	}
+
+	if (atexit_summary) {
+		buf[0] = '\0';
+		if (atexit_summary & SUMMARY_BY_LINE) {
+			strcat(buf, "byline");
+		}
+		if (atexit_summary & SUMMARY_BY_FUNC) {
+			if (buf[0]) {
+				strcat(buf, " | ");
+			}
+			strcat(buf, "byfunc");
+		}
+		if (atexit_summary & SUMMARY_BY_FILE) {
+			if (buf[0]) {
+				strcat(buf, " | ");
+			}
+			strcat(buf, "byfile");
+		}
+	} else {
+		strcpy(buf, "Off");
+	}
+	ast_cli(a->fd, "The atexit summary is: %s\n", buf);
+
+	return CLI_SUCCESS;
+}
+
+static char *handle_memory_show_allocations(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
 {
 	const char *fn = NULL;
 	struct ast_region *reg;
-	unsigned int x;
+	unsigned int idx;
 	unsigned int len = 0;
 	unsigned int cache_len = 0;
 	unsigned int count = 0;
-	unsigned int *fence;
 
 	switch (cmd) {
 	case CLI_INIT:
 		e->command = "memory show allocations";
 		e->usage =
-			"Usage: memory show allocations [<file>]\n"
-			"       Dumps a list of all segments of allocated memory, optionally\n"
-			"       limited to those from a specific file\n";
+			"Usage: memory show allocations [<file>|anomalies]\n"
+			"       Dumps a list of segments of allocated memory.\n"
+			"       Defaults to listing all memory allocations.\n"
+			"       <file> - Restricts output to memory allocated by the file.\n"
+			"       anomalies - Only check for fence violations.\n";
 		return NULL;
 	case CLI_GENERATE:
 		return NULL;
 	}
 
-
-	if (a->argc > 3)
+	if (a->argc == 4) {
 		fn = a->argv[3];
-
-	ast_mutex_lock(&reglock);
-	for (x = 0; x < SOME_PRIME; x++) {
-		for (reg = regions[x]; reg; reg = reg->next) {
-			if (!fn || !strcasecmp(fn, reg->file) || !strcasecmp(fn, "anomolies")) {
-				fence = (unsigned int *)(reg->data + reg->len);
-				if (reg->fence != FENCE_MAGIC) {
-					astmm_log("WARNING: Low fence violation at %p, "
-						"in %s of %s, line %d\n", reg->data, 
-						reg->func, reg->file, reg->lineno);
+	} else if (a->argc != 3) {
+		return CLI_SHOWUSAGE;
 				}
-				if (get_unaligned_uint32(fence) != FENCE_MAGIC) {
-					astmm_log("WARNING: High fence violation at %p, in %s of %s, "
-						"line %d\n", reg->data, reg->func, reg->file, reg->lineno);
+
+	/* Look for historical misspelled option as well. */
+	if (fn && (!strcasecmp(fn, "anomalies") || !strcasecmp(fn, "anomolies"))) {
+		regions_check_all_fences();
+		ast_cli(a->fd, "Anomaly check complete.\n");
+		return CLI_SUCCESS;
 				}
+
+	ast_mutex_lock(&reglock);
+	for (idx = 0; idx < ARRAY_LEN(regions); ++idx) {
+		for (reg = regions[idx]; reg; reg = AST_LIST_NEXT(reg, node)) {
+			if (fn && strcasecmp(fn, reg->file)) {
+				continue;
 			}
-			if (!fn || !strcasecmp(fn, reg->file)) {
-				ast_cli(a->fd, "%10d bytes allocated%s in %20s at line %5d of %s\n", 
-					(int) reg->len, reg->cache ? " (cache)" : "", 
+
+			region_check_fences(reg);
+
+			ast_cli(a->fd, "%10u bytes allocated%s by %20s() line %5u of %s\n",
+				(unsigned int) reg->len, reg->cache ? " (cache)" : "",
 					reg->func, reg->lineno, reg->file);
+
 				len += reg->len;
-				if (reg->cache)
+			if (reg->cache) {
 					cache_len += reg->len;
-				count++;
 			}
+			++count;
 		}
 	}
 	ast_mutex_unlock(&reglock);
 	
-	if (cache_len)
-		ast_cli(a->fd, "%d bytes allocated (%d in caches) in %d allocations\n", len, cache_len, count);
-	else
-		ast_cli(a->fd, "%d bytes allocated in %d allocations\n", len, count);
+	if (cache_len) {
+		ast_cli(a->fd, "%u bytes allocated (%u in caches) in %u allocations\n",
+			len, cache_len, count);
+	} else {
+		ast_cli(a->fd, "%u bytes allocated in %u allocations\n", len, count);
+	}
 	
 	return CLI_SUCCESS;
 }
 
 static char *handle_memory_show_summary(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
 {
+#define my_max(a, b) ((a) >= (b) ? (a) : (b))
+
 	const char *fn = NULL;
-	int x;
+	int idx;
+	int cmp;
 	struct ast_region *reg;
 	unsigned int len = 0;
 	unsigned int cache_len = 0;
-	int count = 0;
+	unsigned int count = 0;
 	struct file_summary {
-		char fn[80];
-		int len;
-		int cache_len;
-		int count;
 		struct file_summary *next;
-	} *list = NULL, *cur;
+		unsigned int len;
+		unsigned int cache_len;
+		unsigned int count;
+		unsigned int lineno;
+		char name[my_max(sizeof(reg->file), sizeof(reg->func))];
+	} *list = NULL, *cur, **prev;
 	
 	switch (cmd) {
 	case CLI_INIT:
@@ -411,37 +817,77 @@
 		e->usage =
 			"Usage: memory show summary [<file>]\n"
 			"       Summarizes heap memory allocations by file, or optionally\n"
-			"by function, if a file is specified\n";
+			"       by line, if a file is specified.\n";
 		return NULL;
 	case CLI_GENERATE:
 		return NULL;
 	}
 
-	if (a->argc > 3) 
+	if (a->argc == 4) {
 		fn = a->argv[3];
+	} else if (a->argc != 3) {
+		return CLI_SHOWUSAGE;
+	}
 
 	ast_mutex_lock(&reglock);
-	for (x = 0; x < SOME_PRIME; x++) {
-		for (reg = regions[x]; reg; reg = reg->next) {
-			if (fn && strcasecmp(fn, reg->file))
+	for (idx = 0; idx < ARRAY_LEN(regions); ++idx) {
+		for (reg = regions[idx]; reg; reg = AST_LIST_NEXT(reg, node)) {
+			if (fn) {
+				if (strcasecmp(fn, reg->file)) {
 				continue;
+				}
 
-			for (cur = list; cur; cur = cur->next) {
-				if ((!fn && !strcmp(cur->fn, reg->file)) || (fn && !strcmp(cur->fn, reg->func)))
+				/* Sort list by func/lineno.  Find existing or place to insert. */
+				for (prev = &list; (cur = *prev); prev = &cur->next) {
+					cmp = strcmp(cur->name, reg->func);
+					if (cmp < 0) {
+						continue;
+					}
+					if (cmp > 0) {
+						/* Insert before current */
+						cur = NULL;
+						break;
+					}
+					cmp = cur->lineno - reg->lineno;
+					if (cmp < 0) {
+						continue;
+					}
+					if (cmp > 0) {
+						/* Insert before current */
+						cur = NULL;
+					}
 					break;
 			}
+			} else {
+				/* Sort list by filename.  Find existing or place to insert. */
+				for (prev = &list; (cur = *prev); prev = &cur->next) {
+					cmp = strcmp(cur->name, reg->file);
+					if (cmp < 0) {
+						continue;
+					}
+					if (cmp > 0) {
+						/* Insert before current */
+						cur = NULL;
+					}
+					break;
+				}
+			}
+
 			if (!cur) {
 				cur = ast_alloca(sizeof(*cur));
 				memset(cur, 0, sizeof(*cur));
-				ast_copy_string(cur->fn, fn ? reg->func : reg->file, sizeof(cur->fn));
-				cur->next = list;
-				list = cur;
+				cur->lineno = reg->lineno;
+				ast_copy_string(cur->name, fn ? reg->func : reg->file, sizeof(cur->name));
+
+				cur->next = *prev;
+				*prev = cur;
 			}
 
 			cur->len += reg->len;
-			if (reg->cache)
+			if (reg->cache) {
 				cur->cache_len += reg->len;
-			cur->count++;
+			}
+			++cur->count;
 		}
 	}
 	ast_mutex_unlock(&reglock);
